package ${package};

import ${package}.ejb.${object}Facade;
import com.vaadin.cdi.CDIView;
import com.vaadin.navigator.View;
import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.ui.Notification;
import javax.annotation.PostConstruct;
import javax.inject.Inject;
import org.vaadin.maddon.fields.MTable;
import org.vaadin.maddon.label.Header;
import org.vaadin.maddon.layouts.MVerticalLayout;

@CDIView("${object?lower_case}")
public class ${object}TableView extends MVerticalLayout implements View {

    @Inject
    ${object}Facade cf;
    @Inject
    ${object}MaddonForm form;

    MTable<${object}> table = new MTable<>(${object}.class);

    @PostConstruct
    public void initComponent() {
        form.setResetHandler(this::reset);
        form.setSavedHandler(this::save);

        table.addMValueChangeListener(e -> {
            form.setEntity(e.getValue());
        });
        listEntities();
        addComponents(
                new Header("${object} listing"),
                table, 
                form
        );
    }

    private void listEntities() {
        table.setBeans(cf.findAll());
    }

    public void save(${object} entity) {
        if (entity.get${idfield.simpleName?cap_first}() == null) {
            cf.create(entity);
        } else {
            cf.edit(entity);
        }
        listEntities();
        Notification.show("Saved!");
    }

    public void reset(${object} entity) {
        // just hide the form
        form.setEntity(null);
        listEntities();
    }

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
    }

}
